
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class DocumentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const documents = await db.documents.create(
            {
                id: data.id || undefined,
        
        document_type: data.document_type
        ||
        null
            ,
            
        file_name: data.file_name
        ||
        null
            ,
            
        mime_type: data.mime_type
        ||
        null
            ,
            
        file_size_bytes: data.file_size_bytes
        ||
        null
            ,
            
        storage_key: data.storage_key
        ||
        null
            ,
            
        public_url: data.public_url
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
        is_private: data.is_private
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await documents.setTenant( data.tenant || null, {
            transaction,
        });
        
        await documents.setUploaded_by( data.uploaded_by || null, {
            transaction,
        });
        
        await documents.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await documents.setBooking_request( data.booking_request || null, {
            transaction,
        });
        
        await documents.setReservation( data.reservation || null, {
            transaction,
        });
        
        await documents.setService_request( data.service_request || null, {
            transaction,
        });
        
        await documents.setInvoice( data.invoice || null, {
            transaction,
        });
        

        

        

        return documents;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const documentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                document_type: item.document_type
            ||
            null
            ,
            
                file_name: item.file_name
            ||
            null
            ,
            
                mime_type: item.mime_type
            ||
            null
            ,
            
                file_size_bytes: item.file_size_bytes
            ||
            null
            ,
            
                storage_key: item.storage_key
            ||
            null
            ,
            
                public_url: item.public_url
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
                is_private: item.is_private
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const documents = await db.documents.bulkCreate(documentsData, { transaction });

        // For each item created, replace relation files
        

        return documents;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const documents = await db.documents.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.document_type !== undefined) updatePayload.document_type = data.document_type;
        
        
        if (data.file_name !== undefined) updatePayload.file_name = data.file_name;
        
        
        if (data.mime_type !== undefined) updatePayload.mime_type = data.mime_type;
        
        
        if (data.file_size_bytes !== undefined) updatePayload.file_size_bytes = data.file_size_bytes;
        
        
        if (data.storage_key !== undefined) updatePayload.storage_key = data.storage_key;
        
        
        if (data.public_url !== undefined) updatePayload.public_url = data.public_url;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        if (data.is_private !== undefined) updatePayload.is_private = data.is_private;
        
        
        updatePayload.updatedById = currentUser.id;

        await documents.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await documents.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.uploaded_by !== undefined) {
            await documents.setUploaded_by(
              
              data.uploaded_by,
              
              { transaction }
            );
        }
        
        if (data.organization !== undefined) {
            await documents.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.booking_request !== undefined) {
            await documents.setBooking_request(
              
              data.booking_request,
              
              { transaction }
            );
        }
        
        if (data.reservation !== undefined) {
            await documents.setReservation(
              
              data.reservation,
              
              { transaction }
            );
        }
        
        if (data.service_request !== undefined) {
            await documents.setService_request(
              
              data.service_request,
              
              { transaction }
            );
        }
        
        if (data.invoice !== undefined) {
            await documents.setInvoice(
              
              data.invoice,
              
              { transaction }
            );
        }
        

        
        

        

        return documents;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const documents = await db.documents.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of documents) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of documents) {
                await record.destroy({transaction});
            }
        });


        return documents;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const documents = await db.documents.findByPk(id, options);

        await documents.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await documents.destroy({
            transaction
        });

        return documents;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const documents = await db.documents.findOne(
            { where },
            { transaction },
        );

        if (!documents) {
            return documents;
        }

        const output = documents.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await documents.getTenant({
            transaction
        });
        
        
        output.uploaded_by = await documents.getUploaded_by({
            transaction
        });
        
        
        output.organization = await documents.getOrganization({
            transaction
        });
        
        
        output.booking_request = await documents.getBooking_request({
            transaction
        });
        
        
        output.reservation = await documents.getReservation({
            transaction
        });
        
        
        output.service_request = await documents.getService_request({
            transaction
        });
        
        
        output.invoice = await documents.getInvoice({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'uploaded_by',
        
        where: filter.uploaded_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.uploaded_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.uploaded_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.booking_requests,
        as: 'booking_request',
        
        where: filter.booking_request ? {
          [Op.or]: [
            { id: { [Op.in]: filter.booking_request.split('|').map(term => Utils.uuid(term)) } },
            {
              request_code: {
                [Op.or]: filter.booking_request.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.reservations,
        as: 'reservation',
        
        where: filter.reservation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reservation.split('|').map(term => Utils.uuid(term)) } },
            {
              reservation_code: {
                [Op.or]: filter.reservation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.service_requests,
        as: 'service_request',
        
        where: filter.service_request ? {
          [Op.or]: [
            { id: { [Op.in]: filter.service_request.split('|').map(term => Utils.uuid(term)) } },
            {
              summary: {
                [Op.or]: filter.service_request.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.invoices,
        as: 'invoice',
        
        where: filter.invoice ? {
          [Op.or]: [
            { id: { [Op.in]: filter.invoice.split('|').map(term => Utils.uuid(term)) } },
            {
              invoice_number: {
                [Op.or]: filter.invoice.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.file_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'documents',
                        'file_name',
                        filter.file_name,
                    ),
                };
            }
            
            if (filter.mime_type) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'documents',
                        'mime_type',
                        filter.mime_type,
                    ),
                };
            }
            
            if (filter.storage_key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'documents',
                        'storage_key',
                        filter.storage_key,
                    ),
                };
            }
            
            if (filter.public_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'documents',
                        'public_url',
                        filter.public_url,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'documents',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.file_size_bytesRange) {
                const [start, end] = filter.file_size_bytesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    file_size_bytes: {
                    ...where.file_size_bytes,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    file_size_bytes: {
                    ...where.file_size_bytes,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.document_type) {
                where = {
                    ...where,
                document_type: filter.document_type,
            };
            }
            
            if (filter.is_private) {
                where = {
                    ...where,
                is_private: filter.is_private,
            };
            }
            


      

      

      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.documents.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'documents',
                        'file_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.documents.findAll({
            attributes: [ 'id', 'file_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['file_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.file_name,
        }));
    }

    
};

